/* args.h - This file is a part of NutsOS
 *
 * NutsOS
 * Copyright (C) 2013  Free Software Foundation, Inc.
 *
 * NutsOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NutsOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with NutsOS; If not, see <http://www.gnu.org/licenses/>.
 *
 * Valentin Verdier <valentin.verdier03@gmail.com>
 */

#pragma once
#ifndef ARGS_H
#define ARGS_H

#include "types.h"

/* Strcutres de rcupration de contexte */
typedef struct {
	T_dword baseAddr_1;
	T_dword baseAddr_2;
	T_dword size_1;
	T_dword size_2;
	T_dword type;
	T_dword unused;
}__attribute__((packed)) T_memMapEntry;

typedef struct {
	T_byte cursor_X;
	T_byte cursor_Y;
	T_dword phyMemSize;
	T_byte memListEntryNumber;
	T_dword initProcessAddr;
	T_dword initProcessSize;
	T_memMapEntry* memMap;
}__attribute__((packed)) T_kernelArgs;

T_kernelArgs* args;

#endif
