/* print.h - This file is a part of NutsOS
 *
 * NutsOS
 * Copyright (C) 2013  Free Software Foundation, Inc.
 *
 * NutsOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NutsOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with NutsOS; If not, see <http://www.gnu.org/licenses/>.
 *
 * Valentin Verdier <valentin.verdier03@gmail.com>
 */

#pragma once
#ifndef PRINT_H
#define PRINT_H

#include <stdarg.h>
#include "types.h"

#define TEXTCOLOR_BLACK 0x0
#define TEXTCOLOR_DARK_BLUE 0x1
#define TEXTCOLOR_DARK_GREEN 0x2
#define TEXTCOLOR_DARK_CYAN 0x3
#define TEXTCOLOR_DARK_RED 0x4
#define TEXTCOLOR_DARK_MAGENTA 0x5
#define TEXTCOLOR_DARK_BROWN 0x6
#define TEXTCOLOR_DARK_GRAY 0x8
#define TEXTCOLOR_LIGHT_GRAY 0x7
#define TEXTCOLOR_LIGHT_BLUE 0x9
#define TEXTCOLOR_LIGHT_GREEN 0xA
#define TEXTCOLOR_LIGHT_CYAN 0xB
#define TEXTCOLOR_LIGHT_RED 0xC
#define TEXTCOLOR_LIGHT_MAGENTA 0xD
#define TEXTCOLOR_LIGHT_YELLOW 0xE
#define TEXTCOLOR_WHITE 0xF

#define BACK_BLUE 0x1
#define BACK_GREEN 0x2
#define BACK_CYAN 0x3
#define BACK_RED 0x4
#define BACK_MAGENTA 0x5
#define BACK_BROWN 0x6
#define BACK_GRAY 0x7

void printError(char*, ...);
void print(char*, ...);
void printColor(char*, T_byte, ...);

#endif
