/* systemCall.c - This file is a part of NutsOS
 *
 * NutsOS
 * Copyright (C) 2013  Free Software Foundation, Inc.
 *
 * NutsOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * NutsOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with NutsOS; If not, see <http://www.gnu.org/licenses/>.
 *
 * Valentin Verdier <valentin.verdier03@gmail.com>
 */

#include "types.h"
#include "print.h"
#include "process.h"
#include "asm_x86.h"

void ExecSystemCall(int sc_num)
{
	bits8 *arg;
	int i;
	unsigned int a = 1;
	switch(sc_num)
	{
		case 1:
			asm("mov %%ebx, %0" :: "m" (arg));
			PutCharVterm(*arg, 0x0F, CurrentProcess->vterm);
			break;

		case 2:
			asm("mov %%ebx, %0" :: "m" (arg));
			ReadInputVterm(arg, CurrentProcess->vterm);
			break;

		case 3:
			/*asm("mov %%ebx, %0" :: "m" (arg));
			if(!CreateProcess(arg, 1))
			{
				CurrentProcess->status = 2;
				Schedule();
			}*/
			break;

		case 4:
			DestroyProcess();

		case 5:
			CurrentProcess->status = 2;
			Schedule();
			/*while(CurrentProcess->status == 2)
			{
				asm("hlt");
			}*/
			break;

		default:
			print("ERREUR : UNKNOW SYSTEM CALL !\n", 0x47);
			_ClearInterrupt();
			asm("hlt");
			break;
	}
	return;
}
